Форум программистов, компьютерный форум CyberForum.ru
Наши страницы

try-catch - C++

Войти
Регистрация
Восстановить пароль
Другие темы раздела
C++ Дано натуральное число (6 значное) записать его шестью цифрами, используя девятисегментный шаблон http://www.cyberforum.ru/cpp-beginners/thread770659.html
Добрый день. Недавно раздали нам задания и я не могу понять как его делать. 1 Дано натуральное число (6 значное) записать его шестью цифрами, используя девятисегментный шаблон. Я думал поначалу...
C++ difference between debug and release MVS2010 Ума не приложу в какую сторону копать:read: Следующий фрагмент кода, в Дебаге работает совершенно верно, а в Релизе какие то ошибки если конкретно не работает оператор cin>>searchKey; case '2':... http://www.cyberforum.ru/cpp-beginners/thread770651.html
посоветуйте хороший учебник по с++ C++
спасибо!
C++ виртуальная функция
class B { private: int a; int b; public: virtual void show();//есть виртуальная функция,которая выводит a и b } class N:public B {
C++ Задача с olympiads.ru http://www.cyberforum.ru/cpp-beginners/thread770616.html
Всем привет. Столкнулся с проблемой при решении задачи E "Распродажа" с сайла olympiads.ru (http://olympiads.ru/zaoch/2012-13/problems/index.shtml) Написал код: #include <iostream> #include...
C++ Определить треугольники минимальной и максимальной площади, которые можно построить из отрезков 13. Известны длины отрезков a, b, c и d. Определить треугольники минимальной и максимальной площади, которые можно построить из этих отрезков. помогите решить эту задачу с помощью <stdio.h>... подробнее

Показать сообщение отдельно
yoghurt92
374 / 345 / 22
Регистрация: 17.05.2012
Сообщений: 1,049

try-catch - C++

24.01.2013, 14:34. Просмотров 501. Ответов 4
Метки (Все метки)

Доброго времени суток, начал изучать исключения, и вот есть такой код:

C++
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
// new.cpp : Defines the entry point for the console application.
//
 
#include "stdafx.h"
#include <iostream>
#include <locale.h>
using namespace std;
 
/*определения класса DivideByZeroErrorиспользуемого при 
обработке исключения, генерируемого делением на нуль*/
class DivideByZeroError
{
    public:
        DivideByZeroError():message(L"Деление на нуль!") {}
        void printMessage() const {wcout << message; }
 
    private:
        const wchar_t *message;
        int num;
};
 
/*описание функции quotient, которая используется чтобы показать
генерацию исключения при ошибке деления на нуль*/
float quotient(int num1, int num2)
{
    else if(num2 == 0)
        throw DivideByZeroError();
 
    return (float) num1 / num2;
}
 
int _tmain(int argc, _TCHAR* argv[])
{
    wcout.imbue(locale(".866"));
    wcout << L"Введите два целых числа для расчета их частного: ";
 
    int number1, number2;
    cin >> number1 >> number2;
 
    try{//включает код, который может сгенерировать исключение
        float result = quotient(number1, number2);
 
        wcout << L"Частное равно: " << result << "\n";
    }
 
    catch(DivideByZeroError error) {//обработчик ошибки
        wcout << L"ОШИБКА!";
        error.printMessage();
        cout << "\n";
 
        return 1;           //завершение при ошибке
    }
 
    return 0;       //нормальное завершение
}
А потом захотел сделать несколько блоков catch чтобы посмотреть как это все работает, но получил сам ошибку...

C++
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63
64
65
66
67
// new.cpp : Defines the entry point for the console application.
//
 
#include "stdafx.h"
#include <iostream>
#include <locale.h>
using namespace std;
 
/*определения класса DivideByZeroErrorиспользуемого при 
обработке исключения, генерируемого делением на нуль*/
class DivideByZeroError
{
    public:
        DivideByZeroError():message(L"Деление на нуль!") {}
        DivideByZeroError(int _num):message(L"Деление на нуль!"), num(_num) {}
        void printMessage() const {wcout << message; }
 
    private:
        const wchar_t *message;
        int num;
};
 
/*описание функции quotient, которая используется чтобы показать
генерацию исключения при ошибке деления на нуль*/
float quotient(int num1, int num2)
{
    if(num2 == 0)
        throw DivideByZeroError(num2);
    else if(num2 == 1)
        throw DivideByZeroError();
 
    return (float) num1 / num2;
}
 
int _tmain(int argc, _TCHAR* argv[])
{
    wcout.imbue(locale(".866"));
    wcout << L"Введите два целых числа для расчета их частного: ";
 
 
    int number1, number2;
    cin >> number1 >> number2;
 
    try{//включает код, который может сгенерировать исключение
        float result = quotient(number1, number2);
 
        wcout << L"Частное равно: " << result << "\n";
    }
 
    catch(DivideByZeroError error) {//обработчик ошибки
        wcout << L"ОШИБКА!";
        error.printMessage();
        cout << "\n";
 
        return 1;           //завершение при ошибке
    }
 
    catch(DivideByZeroError error1(number2)) {//обработчик ошибки
        wcout << L"ОШИБКА!";
        error1.printMessage();
        cout << "\n";
 
        return 1;           //завершение при ошибке
    }
 
    return 0;       //нормальное завершение
}
и вот что вылезло...

C++
1
2
 error C2061: syntax error : identifier 'number2'
 error C2228: left of '.printMessage' must have class/struct/union
Заранее благодарю за помощь!
0
Надоела реклама? Зарегистрируйтесь и она исчезнет полностью.
 
КиберФорум - форум программистов, компьютерный форум, программирование
Powered by vBulletin® Version 3.8.9
Copyright ©2000 - 2017, vBulletin Solutions, Inc.
Рейтинг@Mail.ru